---
sidebar_position: 17
description: Get object upload link and other functions to work with S3 in the Open Integration Package, a free open-source integration library for 1C:Enterprise 8, OneScript and CLI
keywords: [1C, 1С, 1С:Enterprise, 1С:Enterprise 8.3, API, Integration, Services, Exchange, OneScript, CLI, S3]
---

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

# Get object upload link
 Gets a direct link to upload (put) an object without additional authorization



`Function GetObjectUploadLink(Val Name, Val Bucket, Val BasicData, Val Expire = 3600, Val Headers = Undefined, Val Directory = False) Export`

  | Parameter | CLI option | Type | Required | Description |
  |-|-|-|-|-|
  | Name | --name | String | &#x2714; | Name of the object in the bucket |
  | Bucket | --bucket | String | &#x2714; | Name of the bucket to put the object |
  | BasicData | --basic | Structure Of KeyAndValue | &#x2714; | Basic request data. See GetBasicDataStructure |
  | Expire | --expires | String, Number | &#x2716; | Link lifetime in seconds. 604800 max. |
  | Headers | --headers | Map Of KeyAndValue | &#x2716; | Additional request headers, if necessary |
  | Directory | --dir | Boolean | &#x2716; | True > Path style URL, False > Virtual hosted style URL |

  
  Returns:  String - URL for object retrieving

:::tip
In Headers you need to add all x-amz headers that will be used when accessing the received URL

Process at AWS documentation: [Download and upload objects with presigned URLs](https://docs.aws.amazon.com/AmazonS3/latest/userguide/using-presigned-url.html)
:::
<br/>


```bsl title="1C:Enterprise/OneScript code example"
    URL       = "storage-155.s3hoster.by";
    AccessKey = "BRN5RKJE67...";
    SecretKey = "NNhv+i9PrytpT8Tu0C1N...";
    Region    = "BTC";

    BasicData = OPI_S3.GetBasicDataStructure(URL, AccessKey, SecretKey, Region);

    Name = "pictureU.jpg";

    Directory = True; // Formation URL in path-style
    Bucket = "newbucket2";

    Result = OPI_S3.GetObjectUploadLink(Name, Bucket, BasicData, 7200, , Directory);
```
 

 <Tabs>
  
    <TabItem value="bash" label="Bash" default>
        ```bash
            # JSON data can also be passed as a path to a .json file
            
            oint s3 GetObjectUploadLink \
             --name "pictureU.jpg" \
             --bucket "newbucket2" \
             --basic "{'URL':'storage-564.s3hoster.by','AccessKey':'***','SecretKey':'***','Region':'BTC','Service':'s3'}" \
             --expires 7200 \
             --dir true
        ```
    </TabItem>
  
    <TabItem value="bat" label="CMD/Bat" default>
        ```batch
            :: JSON data can also be passed as a path to a .json file
            
            oint s3 GetObjectUploadLink ^
             --name "pictureU.jpg" ^
             --bucket "newbucket2" ^
             --basic "{'URL':'storage-564.s3hoster.by','AccessKey':'***','SecretKey':'***','Region':'BTC','Service':'s3'}" ^
             --expires 7200 ^
             --dir true
        ```
    </TabItem>
</Tabs>


```json title="Result"
"storage-564.s3hoster.by/newbucket2/pictureU.jpg?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=H71HC7EBMR30IOA3DFNE%2F20251210%2FBTC%2Fs3%2Faws4_request&X-Amz-Date=20251210T204603Z&X-Amz-Expires=7200&X-Amz-SignedHeaders=host&X-Amz-Signature=d65fc6fbd3375f80b1f01a3ea31c6194908f2a47a014075fe467d46513efe8ff"
```
